searchNodes=[{"doc":"JSON console back-end for Elixir Logger. It can be used as drop-in replacement for default :console Logger back-end in cases where you use use Google Cloud Logger or other JSON-based log collectors. Log Format LoggerJSON provides three JSON formatters out of the box. You can change this structure by implementing LoggerJSON.Formatter behaviour and passing module name to :formatter config option. Example implementations can be found in LoggerJSON.Formatters.GoogleCloudLogger , LoggerJSON.Formatters.DatadogLogger , and LoggerJSON.Formatters.BasicLogger . config :logger_json , :backend , formatter : MyFormatterImplementation If your formatter supports different options, you can specify them with :formatter_opts . config :logger_json , :backend , formatter : LoggerJSON.Formatters.DatadogLogger , formatter_opts : %{ hostname : &quot;example.com&quot; } Encoders support You can replace default Jason encoder with other module that supports encode!/1 function. This can be even used as custom formatter callback. Popular Jason alternatives: poison . exjsx . elixir-json - native Elixir encoder implementation. jiffy . Dynamic configuration For dynamically configuring the endpoint, such as loading data from environment variables or configuration files, LoggerJSON provides an :on_init option that allows developers to set a module, function and list of arguments that is invoked when the endpoint starts. If you would like to disable the :on_init callback function dynamically, you can pass in :disabled and no callback function will be called. config :logger_json , :backend , on_init : { YourApp.Logger , :load_from_system_env , [ ] }","ref":"LoggerJSON.html","title":"LoggerJSON","type":"module"},{"doc":"Callback implementation for :gen_event.code_change/3 .","ref":"LoggerJSON.html#code_change/3","title":"LoggerJSON.code_change/3","type":"function"},{"doc":"Changes Logger log level at runtime. Notice that settings this value below compile_time_purge_level would not work, because Logger calls would be already stripped at compile-time.","ref":"LoggerJSON.html#configure_log_level!/1","title":"LoggerJSON.configure_log_level!/1","type":"function"},{"doc":"Configures Logger log level at runtime by using value from environment variable. By default, 'LOG_LEVEL' environment variable is used.","ref":"LoggerJSON.html#configure_log_level_from_env!/1","title":"LoggerJSON.configure_log_level_from_env!/1","type":"function"},{"doc":"Callback implementation for :gen_event.handle_call/2 .","ref":"LoggerJSON.html#handle_call/2","title":"LoggerJSON.handle_call/2","type":"function"},{"doc":"Callback implementation for :gen_event.handle_event/2 .","ref":"LoggerJSON.html#handle_event/2","title":"LoggerJSON.handle_event/2","type":"function"},{"doc":"Callback implementation for :gen_event.handle_info/2 .","ref":"LoggerJSON.html#handle_info/2","title":"LoggerJSON.handle_info/2","type":"function"},{"doc":"Callback implementation for :gen_event.init/1 .","ref":"LoggerJSON.html#init/1","title":"LoggerJSON.init/1","type":"function"},{"doc":"","ref":"LoggerJSON.html#take_metadata/3","title":"LoggerJSON.take_metadata/3","type":"function"},{"doc":"Callback implementation for :gen_event.terminate/2 .","ref":"LoggerJSON.html#terminate/2","title":"LoggerJSON.terminate/2","type":"function"},{"doc":"Implements the behaviour of Ecto.LogEntry and sends query as a string to Logger with additional metadata: query.execution_time_μs - the time spent executing the query in microseconds; query.decode_time_μs - the time spent decoding the result in microseconds (it may be 0); query.queue_time_μs - the time spent to check the connection out in microseconds (it may be 0); query.duration_μs - time the query taken (sum of query_time , decode_time and queue_time ); connection_pid - the connection process that executed the query; ansi_color - the color that should be used when logging the entry. For more information see LogEntry source code.","ref":"LoggerJSON.Ecto.html","title":"LoggerJSON.Ecto","type":"module"},{"doc":"Logs query string with metadata from Ecto.LogEntry in with debug level.","ref":"LoggerJSON.Ecto.html#log/1","title":"LoggerJSON.Ecto.log/1","type":"function"},{"doc":"Overwritten to use JSON. Logs the given entry in the given level.","ref":"LoggerJSON.Ecto.html#log/2","title":"LoggerJSON.Ecto.log/2","type":"function"},{"doc":"","ref":"LoggerJSON.Ecto.html#telemetry_logging_handler/4","title":"LoggerJSON.Ecto.telemetry_logging_handler/4","type":"function"},{"doc":"Behaviour that should be implemented by log formatters. Example implementations can be found in LoggerJSON.Formatters.GoogleCloudLogger and LoggerJSON.Formatters.BasicLogger .","ref":"LoggerJSON.Formatter.html","title":"LoggerJSON.Formatter","type":"behaviour"},{"doc":"Format event callback. Returned map will be encoded to JSON.","ref":"LoggerJSON.Formatter.html#c:format_event/6","title":"LoggerJSON.Formatter.format_event/6","type":"callback"},{"doc":"Initialization callback. Ran on startup with the given formatter_opts list. Returned list will be used as formatter_state in format_event/6 .","ref":"LoggerJSON.Formatter.html#c:init/1","title":"LoggerJSON.Formatter.init/1","type":"callback"},{"doc":"This module contains functions that can be used across different LoggerJSON.Formatter implementations to provide common functionality.","ref":"LoggerJSON.FormatterUtils.html","title":"LoggerJSON.FormatterUtils","type":"module"},{"doc":"Provide a string output of the MFA log entry.","ref":"LoggerJSON.FormatterUtils.html#format_function/2","title":"LoggerJSON.FormatterUtils.format_function/2","type":"function"},{"doc":"","ref":"LoggerJSON.FormatterUtils.html#format_function/3","title":"LoggerJSON.FormatterUtils.format_function/3","type":"function"},{"doc":"Format an exception for use within a log entry.","ref":"LoggerJSON.FormatterUtils.html#format_process_crash/1","title":"LoggerJSON.FormatterUtils.format_process_crash/1","type":"function"},{"doc":"RFC3339 UTC &quot;Zulu&quot; format.","ref":"LoggerJSON.FormatterUtils.html#format_timestamp/1","title":"LoggerJSON.FormatterUtils.format_timestamp/1","type":"function"},{"doc":"Optionally put a value to a map.","ref":"LoggerJSON.FormatterUtils.html#maybe_put/3","title":"LoggerJSON.FormatterUtils.maybe_put/3","type":"function"},{"doc":"Basic JSON log formatter with no vendor specific formatting.","ref":"LoggerJSON.Formatters.BasicLogger.html","title":"LoggerJSON.Formatters.BasicLogger","type":"module"},{"doc":"DataDog formatter. This will adhere to the default standard attribute list as much as possible. Options This formatter has a couple of options to fine tune the logging output for your deployed environment. hostname By setting the hostname value, you can change how the syslog.hostname is set in logs. In most cases, you can leave this unset and it will use default to :system , which uses :inet.gethostname/0 to resolve the value. If you are running in an environment where the hostname is not correct, you can hard code it by setting hostname to a string. In places where the hostname is inaccurate but also dynamic (like Kubernetes), you can set hostname to :unset to exclude it entirely. You'll then be relying on dd-agent to determine the hostname.","ref":"LoggerJSON.Formatters.DatadogLogger.html","title":"LoggerJSON.Formatters.DatadogLogger","type":"module"},{"doc":"Google Cloud Logger formatter.","ref":"LoggerJSON.Formatters.GoogleCloudLogger.html","title":"LoggerJSON.Formatters.GoogleCloudLogger","type":"module"},{"doc":"Builds structured payload which is mapped to Google Cloud Logger LogEntry format. See: https://cloud.google.com/logging/docs/agent/configuration#special_fields_in_structured_payloads","ref":"LoggerJSON.Formatters.GoogleCloudLogger.html#format_event/6","title":"LoggerJSON.Formatters.GoogleCloudLogger.format_event/6","type":"function"},{"doc":"Google Error Reporter formatter.","ref":"LoggerJSON.Formatters.GoogleErrorReporter.html","title":"LoggerJSON.Formatters.GoogleErrorReporter","type":"module"},{"doc":"","ref":"LoggerJSON.Formatters.GoogleErrorReporter.html#report/4","title":"LoggerJSON.Formatters.GoogleErrorReporter.report/4","type":"function"},{"doc":"Utilities for converting metadata into data structures that can be safely passed to Jason.encode!/1 .","ref":"LoggerJSON.JasonSafeFormatter.html","title":"LoggerJSON.JasonSafeFormatter","type":"module"},{"doc":"Produces metadata that is &quot;safe&quot; for calling Jason.encode!/1 on without errors. This means that unexpected Logger metadata won't cause logging crashes. Current formatting is... Maps: as is Printable binaries: as is Numbers: as is Structs that don't implement Jason.Encoder: converted to maps Tuples: converted to lists Keyword lists: converted to Maps everything else: inspected","ref":"LoggerJSON.JasonSafeFormatter.html#format/1","title":"LoggerJSON.JasonSafeFormatter.format/1","type":"function"},{"doc":"","ref":"LoggerJSON.JasonSafeFormatter.html#jason_implemented?/1","title":"LoggerJSON.JasonSafeFormatter.jason_implemented?/1","type":"function"},{"doc":"A Plug to log request information in JSON format.","ref":"LoggerJSON.Plug.html","title":"LoggerJSON.Plug","type":"module"},{"doc":"Initializes the Plug. Available options :log - log level which is used to log requests; :version_header - request header which is used to determine API version requested by client, default: x-api-version ; :metadata_formatter - module with build_metadata/3 function that formats the metadata before it's sent to logger, default - LoggerJSON.Plug.MetadataFormatters.GoogleCloudLogger . Available metadata formatters LoggerJSON.Plug.MetadataFormatters.DatadogLogger see module for logged structure; LoggerJSON.Plug.MetadataFormatters.GoogleCloudLogger leverages GCP LogEntry format; LoggerJSON.Plug.MetadataFormatters.ELK see module for logged structure.","ref":"LoggerJSON.Plug.html#init/1","title":"LoggerJSON.Plug.init/1","type":"function"},{"doc":"This formatter builds a metadata which is natively supported by Datadog: http - see DataDog ; phoenix.controller - Phoenix controller that processed the request; phoenix.action - Phoenix action that processed the request;","ref":"LoggerJSON.Plug.MetadataFormatters.DatadogLogger.html","title":"LoggerJSON.Plug.MetadataFormatters.DatadogLogger","type":"module"},{"doc":"Formats connection into Logger metadata: connection.type - type of connection (Sent or Chunked); connection.method - HTTP request method; connection.request_path - HTTP request path; connection.status - HTTP status code sent to a client; client.user_agent - value of User-Agent header; client.ip' - value of X-Forwarded-For header if present, otherwise - remote IP of a connected client; * client.api_version' - version of API that was requested by a client; node.hostname - system hostname; node.vm_pid - Erlang VM process identifier; phoenix.controller - Phoenix controller that processed the request; phoenix.action - Phoenix action that processed the request; latency_μs - time in microseconds taken to process the request.","ref":"LoggerJSON.Plug.MetadataFormatters.ELK.html","title":"LoggerJSON.Plug.MetadataFormatters.ELK","type":"module"},{"doc":"This formatter builds a metadata which is natively supported by Google Cloud Logger: httpRequest - see LogEntry#HttpRequest ; client.api_version - version of API that was requested by a client; phoenix.controller - Phoenix controller that processed the request; phoenix.action - Phoenix action that processed the request; node.hostname - node hostname; node.vm_pid - Erlang VM process identifier.","ref":"LoggerJSON.Plug.MetadataFormatters.GoogleCloudLogger.html","title":"LoggerJSON.Plug.MetadataFormatters.GoogleCloudLogger","type":"module"},{"doc":"This module contains functions that can be used across different LoggerJSON.Plug.MetadataFormatters implementations to provide common functionality.","ref":"LoggerJSON.PlugUtils.html","title":"LoggerJSON.PlugUtils","type":"module"},{"doc":"Grabs the client IP address from Plug.Conn . First we try to grab the client IP from the x-forwarded-for header. Then we fall back to the conn.remote_ip field.","ref":"LoggerJSON.PlugUtils.html#remote_ip/1","title":"LoggerJSON.PlugUtils.remote_ip/1","type":"function"},{"doc":"The MIT License (MIT) Copyright (c) 2016 Nebo #15 Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License","type":"extras"},{"doc":"LoggerJSON JSON console back-end for Elixir Logger. It can be used as drop-in replacement for default :console Logger back-end in cases where you use use Google Cloud Logger, DataDog or other JSON-based log collectors. After adding this back-end you may also be interested in redirecting otp and sasl reports to Logger (see &quot;Error Logger configuration&quot; section). Minimum supported Erlang/OTP version is 20.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"LoggerJSON provides three JSON formatters out of the box and allows developers to implement a custom one. BasicLogger The LoggerJSON.Formatters.BasicLogger formatter provides a generic JSON formatted message with no vendor specific entries in the payload. A sample log entry from LoggerJSON.Formatters.BasicLogger looks like the following: { &quot;time&quot;: &quot;2020-04-02T11:59:06.710Z&quot;, &quot;severity&quot;: &quot;debug&quot;, &quot;message&quot;: &quot;hello&quot;, &quot;metadata&quot;: { &quot;user_id&quot;: 13 } } GoogleCloudLogger Generates JSON that is compatible with the Google Cloud Logger LogEntry format: { &quot;message&quot;:&quot;hello&quot;, &quot;logging.googleapis.com/sourceLocation&quot;:{ &quot;file&quot;:&quot;/os/logger_json/test/unit/logger_json_test.exs&quot;, &quot;function&quot;:&quot;Elixir.LoggerJSONGoogleTest.test metadata can be configured/1&quot;, &quot;line&quot;:71 }, &quot;severity&quot;:&quot;DEBUG&quot;, &quot;time&quot;:&quot;2018-10-19T01:10:49.582Z&quot;, &quot;user_id&quot;:13 } Notice that GKE doesn't allow to set certain fields of the LogEntry, so support is limited. The results in Google Cloud Logger would looks something like this: { &quot;httpRequest&quot;:{ &quot;latency&quot;:&quot;0.350s&quot;, &quot;remoteIp&quot;:&quot;::ffff:10.142.0.2&quot;, &quot;requestMethod&quot;:&quot;GET&quot;, &quot;requestPath&quot;:&quot;/&quot;, &quot;requestUrl&quot;:&quot;http://10.16.0.70/&quot;, &quot;status&quot;:200, &quot;userAgent&quot;:&quot;kube-probe/1.10+&quot; }, &quot;insertId&quot;:&quot;1g64u74fgmqqft&quot;, &quot;jsonPayload&quot;:{ &quot;message&quot;:&quot;&quot;, &quot;phoenix&quot;:{ &quot;action&quot;:&quot;index&quot;, &quot;controller&quot;:&quot;Elixir.MyApp.Web.PageController&quot;, }, &quot;request_id&quot;:&quot;2lfbl1r3m81c40e5v40004c2&quot;, &quot;vm&quot;:{ &quot;hostname&quot;:&quot;myapp-web-66979fc-vbk4q&quot;, &quot;pid&quot;:1, } }, &quot;logName&quot;:&quot;projects/hammer-staging/logs/stdout&quot;, &quot;metadata&quot;:{ &quot;systemLabels&quot;:{}, &quot;userLabels&quot;:{} }, &quot;operation&quot;:{ &quot;id&quot;:&quot;2lfbl1r3m81c40e5v40004c2&quot; }, &quot;receiveTimestamp&quot;:&quot;2018-10-18T14:33:35.515253723Z&quot;, &quot;resource&quot;:{}, &quot;severity&quot;:&quot;INFO&quot;, &quot;sourceLocation&quot;:{ &quot;file&quot;:&quot;iex&quot;, &quot;function&quot;:&quot;Elixir.LoggerJSON.Plug.call/2&quot;, &quot;line&quot;:&quot;36&quot; }, &quot;timestamp&quot;:&quot;2018-10-18T14:33:33.263Z&quot; } DatadogLogger Adheres to the default standard attribute list . { &quot;domain&quot;: [&quot;elixir&quot;], &quot;duration&quot;: 3863403, &quot;http&quot;: { &quot;url&quot;: &quot;http://localhost/create-account&quot;, &quot;status_code&quot;: 200, &quot;method&quot;: &quot;GET&quot;, &quot;referer&quot;: &quot;http://localhost:4000/login&quot;, &quot;request_id&quot;: &quot;http_FlDCOItxeudZJ20AAADD&quot;, &quot;useragent&quot;: &quot;Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/87.0.4280.66 Safari/537.36&quot;, &quot;url_details&quot;: { &quot;host&quot;: &quot;localhost&quot;, &quot;port&quot;: 4000, &quot;path&quot;: &quot;/create-account&quot;, &quot;queryString&quot;: &quot;&quot;, &quot;scheme&quot;: &quot;http&quot; } }, &quot;logger&quot;: { &quot;thread_name&quot;: &quot;#PID&lt;0.1042.0&gt;&quot;, &quot;method_name&quot;: &quot;Elixir.LoggerJSON.Plug.call/2&quot; }, &quot;message&quot;: &quot;&quot;, &quot;network&quot;: { &quot;client&quot;: { &quot;ip&quot;: &quot;127.0.0.1&quot; } }, &quot;phoenix&quot;: { &quot;controller&quot;: &quot;Elixir.RecognizerWeb.Accounts.UserRegistrationController&quot;, &quot;action&quot;: &quot;new&quot; }, &quot;request_id&quot;: &quot;http_FlDCOItxeudZJ20AAADD&quot;, &quot;syslog&quot;: { &quot;hostname&quot;: [10, 10, 100, 100, 100, 100, 100], &quot;severity&quot;: &quot;info&quot;, &quot;timestamp&quot;: &quot;2020-12-14T19:16:55.088Z&quot; } } Custom formatters You can change this structure by implementing LoggerJSON.Formatter behaviour and passing module name to :formatter config option. Example module can be found in LoggerJSON.Formatters.GoogleCloudLogger . config :logger_json, :backend, formatter: MyFormatterImplementation","ref":"readme.html#log-format","title":"Overview - Log Format","type":"extras"},{"doc":"It's available on Hex , the package can be installed as: Add :logger_json to your list of dependencies in mix.exs : def deps do [{:logger_json, &quot;~&gt; 5.1&quot;}] end Set configuration in your config/config.exs : config :logger_json, :backend, metadata: :all, json_encoder: Jason, formatter: LoggerJSON.Formatters.GoogleCloudLogger Some integrations (for eg. Plug) use metadata to log request and response parameters. You can reduce log size by replacing :all (which means log all metadata) with a list of the ones that you actually need. Beware that LoggerJSON always ignores some metadata keys , but formatters like GoogleCloudLogger and DatadogLogger still persist those metadata values into a structured output. This behavior is similar to the default Elixir logger backend. Replace default Logger :console back-end with LoggerJSON : config :logger, backends: [LoggerJSON] Optionally. Log requests and responses by replacing a Plug.Logger in your endpoint with a: plug LoggerJSON.Plug LoggerJSON.Plug is configured by default to use LoggerJSON.Plug.MetadataFormatters.GoogleCloudLogger . You can replace it with the :metadata_formatter config option. Optionally. Use Ecto telemetry for additional metadata: Attach telemetry handler for Ecto events in start/2 function in application.ex :ok = :telemetry.attach( &quot;logger-json-ecto&quot;, [:my_app, :repo, :query], &amp;LoggerJSON.Ecto.telemetry_logging_handler/4, :debug ) Prevent duplicate logging of events, by setting log configuration option to false config :my_app, MyApp.Repo, adapter: Ecto.Adapters.Postgres, log: false","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"For dynamically configuring the endpoint, such as loading data from environment variables or configuration files, LoggerJSON provides an :on_init option that allows developers to set a module, function and list of arguments that is invoked when the endpoint starts. config :logger_json, :backend, on_init: {YourApp.Logger, :load_from_system_env, []}","ref":"readme.html#dynamic-configuration","title":"Overview - Dynamic configuration","type":"extras"},{"doc":"You can replace default Jason encoder with other module that supports encode_to_iodata!/1 function and encoding fragments.","ref":"readme.html#encoders-support","title":"Overview - Encoders support","type":"extras"},{"doc":"The docs can be found at https://hexdocs.pm/logger_json","ref":"readme.html#documentation","title":"Overview - Documentation","type":"extras"},{"doc":"Many source code has been taken from original Elixir Logger :console back-end source code, so I want to thank all it's authors and contributors. Part of LoggerJSON.Plug module have origins from plug_logger_json by @bleacherreport, originally licensed under Apache License 2.0. Part of LoggerJSON.PlugTest are from Elixir's Plug licensed under Apache 2.","ref":"readme.html#thanks","title":"Overview - Thanks","type":"extras"},{"doc":"Copyright (c) 2016 Nebo #15 Released under the MIT License, which can be found in LICENSE.md .","ref":"readme.html#copyright-and-license","title":"Overview - Copyright and License","type":"extras"}]